<?php
/*
* Copyright (C) 2017 Markus Eberl
*
* This Program is free software; you can redistribute it and/or modify
* it under the terms of the Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) License
* as published by https://creativecommons.org/licenses/by-nc/4.0/legalcode
*
* This Program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
*  file: app/templates/alarm.php
*  version: 1.0 2017-05-11
*  coder: Markus Eberl
 */

$tmpfilename = "newcron";

// POST Handler
if (isset($_POST['line']) || isset($_POST['add'])){
	$tmpfile = fopen("/var/www/$tmpfilename", "w");

	//add already active alarms to newcronjob file (cronjobs can only be wrote all at once)
	if(isset($_POST['line'])) {
		//echo "#################################";
		foreach($_POST['line'] as $alarm){
			$days = array();
			if (isset($alarm['alarmday1'])) $days[] = "1";
			if (isset($alarm['alarmday2'])) $days[] = "2";
			if (isset($alarm['alarmday3'])) $days[] = "3";
			if (isset($alarm['alarmday4'])) $days[] = "4";
			if (isset($alarm['alarmday5'])) $days[] = "5";
			if (isset($alarm['alarmday6'])) $days[] = "6";
			if (isset($alarm['alarmday7'])) $days[] = "7";
			$days = implode(',',$days);

			if($alarm['todo'] != "remove"){
				fwrite($tmpfile, $alarm['alarmmin']." ".$alarm['alarmhour']." * * ".$days." ");
				fwrite($tmpfile,"/usr/bin/mpc clear && /usr/bin/mpc load \"".$alarm['alarmplaylist']."\" && /var/www/mpcfadectl.sh in ".$alarm['alarmvolume']." ".$alarm['alarmfadetime']*60 ."\n");
			}
		}
	}
	$msg =  "Alarms saved";

	if (isset($_POST['add'])){
		$alarm = $_POST[add];
		$days = array();
		if (isset($alarm['alarmday1'])) $days[] = "1";
		if (isset($alarm['alarmday2'])) $days[] = "2";
		if (isset($alarm['alarmday3'])) $days[] = "3";
		if (isset($alarm['alarmday4'])) $days[] = "4";
		if (isset($alarm['alarmday5'])) $days[] = "5";
		if (isset($alarm['alarmday6'])) $days[] = "6";
		if (isset($alarm['alarmday7'])) $days[] = "7";
		$days = implode(',',$days);

		if($alarm['todo'] == "add"){
			fwrite($tmpfile, $alarm['alarmmin']." ".$alarm['alarmhour']." * * ".$days." ");
			fwrite($tmpfile,"/usr/bin/mpc clear && /usr/bin/mpc load \"".$alarm['alarmplaylist']."\" && /var/www/mpcfadectl.sh in ".$alarm['alarmvolume']." ".$alarm['alarmfadetime']*60 ."\n");
		}
		$msg =   "Alarm added";
	}
	fclose($tmpfile);
	shell_exec('crontab /var/www/'.$tmpfilename);

	shell_exec('/usr/bin/rm -f /var/www/'.$tmpfilename);

	header( 'HTTP/1.1 303 See Other' );
    header( 'Location:');
}
?>

<div class="container alarm">
<h1>Alarm</h1>

<?php
	//Messages only show if header reload is removed
	if(isset($msg))	echo "<div class=\"boxed-group\" id=\"airplayBox\">$msg</div>";
?>

<form action="alarm" method="post" class="form-horizontal">
<fieldset>
<legend>Active Alarms</legend>

<?php
    // Read Alarms
	$playlists = 	explode("\n", shell_exec("/usr/bin/mpc lsplaylists"));
	array_pop($playlists); //remove empty last line

	$alarms = 		explode("\n", shell_exec("crontab -l"));
	array_pop($alarms); //remove empty last line

	$line = 1;
	foreach($alarms as $alarm){
		$alarmdata =  explode(" ", $alarm,6);

		$alarmhour = $alarmdata[1];
		$alarmmin = $alarmdata[0];
		$alarmdays = explode(",", $alarmdata[4]);
		$alarmday = array();
		if(in_array("1", $alarmdays)) $alarmday[1] = "checked";
		if(in_array("2", $alarmdays)) $alarmday[2] = "checked";
		if(in_array("3", $alarmdays)) $alarmday[3] = "checked";
		if(in_array("4", $alarmdays)) $alarmday[4] = "checked";
		if(in_array("5", $alarmdays)) $alarmday[5] = "checked";
		if(in_array("6", $alarmdays)) $alarmday[6] = "checked";
		if(in_array("7", $alarmdays)) $alarmday[7] = "checked";

		$alarmplaylist = explode("\"",$alarmdata[5])[1];

		$tmp_data = explode(" ",$alarmdata[5]);
		$alarmvolume = intval($tmp_data[count($tmp_data) - 2]);
		$alarmfadetime = $tmp_data[count($tmp_data) - 1]/60;

		echo "
		<div class=\"container-fluid boxed\" style=\"width:23em; float:left; margin:1em;\">
			<div class=\"form-group\">
				<div class=\"col-sm-10\">
					<legend><b>Alarm ".$line."</b></legend>
				</div>
				<div class=\"col-sm-2\">
					<button type=\"submit\" name=\"line[$line][todo]\" value=\"remove\" class=\"btn btn-primary btn-lg pull-right\" style=\"width:1.5em; height:1.5em; padding:0em;\"><i class=\"fa fa-times\" aria-hidden=\"true\"></i></button>
				</div>
			</div>

			<div class=\"form-group\">
				<label class=\"control-label col-sm-3\" for=\"hostname\">Time:</label>
				<div class=\"col-sm-9\">
					<select name=\"line[$line][alarmhour]\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible;\">";
						for ($i = 0; $i < 24; $i++){
							if (intval($alarmhour) == $i) {
								echo "<option value=\"$i\" selected>$i</option>\n";
							}else{
								echo "<option value=\"$i\">$i</option>\n";
							}
						}
						echo "</select> <span style=\"font-weight:bolder;font-size:1.5em;padding: 0em 0.5em;\">:</span>
					<select name=\"line[$line][alarmmin]\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible;\">";
						for ($i = 0; $i < 60; $i+=5){
							if (intval($alarmmin) == $i) {
								echo "<option value=\"$i\" selected>$i</option>\n";
							}else{
								echo "<option value=\"$i\">$i</option>\n";
							}
						}
						echo "</select>
				</div>
			</div>

			<div class=\"form-group\">
				<label class=\"control-label col-sm-3\" for=\"hostname\">Playlist:</label>
				<div class=\"col-sm-9\">
					<select name=\"line[$line][alarmplaylist]\" id=\"playlist_wrongstyle\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible; width:100%;\">";
						foreach ($playlists as $playlist){
							if ($playlist == $alarmplaylist) {
								echo "<option value=\"$playlist\" selected>$playlist</option>\n";
							}else{
								echo "<option value=\"$playlist\">$playlist</option>\n";
							}
						}
						echo "</select>
				</div>
			</div>

			<div class=\"form-group\" >
				<label class=\"control-label col-sm-3\" for=\"hostname\">Days: </label>
				<div class=\"col-sm-9\">
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday1]\" id=\"A".$line."alarmday1\" value=\"1\" class=\"checkbox-input\" $alarmday[1]><label for=\"A".$line."alarmday1\" class=\"pseudo-checkbox-primary\">Mo</label></div>
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday2]\" id=\"A".$line."alarmday2\" value=\"2\" class=\"checkbox-input\" $alarmday[2]><label for=\"A".$line."alarmday2\" class=\"pseudo-checkbox-primary\">Tu</label></div>
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday3]\" id=\"A".$line."alarmday3\" value=\"3\" class=\"checkbox-input\" $alarmday[3]><label for=\"A".$line."alarmday3\" class=\"pseudo-checkbox-primary\">We</label></div>
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday4]\" id=\"A".$line."alarmday4\" value=\"4\" class=\"checkbox-input\" $alarmday[4]><label for=\"A".$line."alarmday4\" class=\"pseudo-checkbox-primary\">Th</label></div>
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday5]\" id=\"A".$line."alarmday5\" value=\"5\" class=\"checkbox-input\" $alarmday[5]><label for=\"A".$line."alarmday5\" class=\"pseudo-checkbox-primary\">Fr</label></div>
					<div style=\"float:left;clear:left\"><input type=\"checkbox\" name=\"line[$line][alarmday6]\" id=\"A".$line."alarmday6\" value=\"6\" class=\"checkbox-input\" $alarmday[6]><label for=\"A".$line."alarmday6\" class=\"pseudo-checkbox-primary\">Sa</label></div>
					<div style=\"float:left;\"><input type=\"checkbox\" name=\"line[$line][alarmday7]\" id=\"A".$line."alarmday7\" value=\"7\" class=\"checkbox-input\" $alarmday[7]><label for=\"A".$line."alarmday7\" class=\"pseudo-checkbox-primary\">Su</label></div>
				</div>
			</div>


			<div class=\"form-group\" >
				<label class=\"control-label col-sm-3\" for=\"hostname\">Volume: </label>
				<div class=\"col-sm-9\">
					<select name=\"line[$line][alarmvolume]\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible;\">";
						for ($i = 10; $i <= 100; $i+=10){
							if (intval($alarmvolume) == $i) {
								echo "<option value=\"$i\" selected>$i %</option>\n";
							}else{
								echo "<option value=\"$i\">$i %</option>\n";
							}
						}
						echo "</select>
				</div>
			</div>

			<div class=\"form-group\" >
				<label class=\"control-label col-sm-3\" for=\"hostname\">Fade: </label>
				<div class=\"col-sm-9\">
					<select name=\"line[$line][alarmfadetime]\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible;\">";
						$fadetimearray = array(0,1,5,10,15,30);
						foreach ($fadetimearray as $i){
							if (intval($alarmfadetime) == $i) {
								echo "<option value=\"$i\" selected>$i min</option>\n";
							}else{
								echo "<option value=\"$i\">$i min</option>\n";
							}
						}
						echo "</select>
				</div>
			</div>
			<div class=\"form-group\" >
				<label class=\"control-label col-sm-3\" for=\"hostname\">Timeout: </label>
				<div class=\"col-sm-9\">
					<select name=\"line[$line][alarmtimeout]\" class=\"btn btn-primary btn-lg\" style=\"visibility:visible;\">";
						$timeoutarray = array(0,30,60,90,120,180,240);
						foreach ($timeoutarray as $i){
							if (intval($timeoutarray) == $i) {
								echo "<option value=\"$i\" selected>$i min</option>\n";
							}else{
								echo "<option value=\"$i\">$i min</option>\n";
							}
						}
						echo "</select>
				</div>
			</div>

		<div class=\"form-group\">
			<div class=\"col-sm-12\">
				<button type=\"submit\" name=\"line[$line][todo]\" value=\"save\" class=\"btn btn-primary btn-lg pull-right\">Save</button>
			</div>
		</div>
	</div>";
	$line++;
	}
?>


<legend>Add Alarm</legend>

<div class="container-fluid boxed" style="width:23em; float:left; margin:1em;">
	<div class="form-group">
		<label class="control-label col-sm-3" for="hostname">Time:</label>
		<div class="col-sm-9">
			<select name="add[alarmhour]" class="btn dropdown btn-default btn-lg" style="visibility:visible;">
				<?php for ($i = 0; $i < 24; $i++){echo "<option value=\"$i\">$i</option>\n";} ?>
			</select><span style="font-weight:bolder;font-size:1.5em;padding: 0em 0.5em;">:</span>
			<select name="add[alarmmin]" class="btn dropdown btn-default btn-lg" style="visibility:visible;">
				<?php for ($i = 0; $i < 60; $i+=5){echo "<option value=\"$i\">$i</option>\n";} ?>
			</select>
		</div>
	</div>

	<div class="form-group">
		<label class="control-label col-sm-3" for="hostname">Playlist: </label>
		<div class="col-sm-9">
			<select name="add[alarmplaylist]" id="playlist_wrongstyle" class="btn dropdown btn-default btn-lg"  style="visibility:visible; width:100%">
				<?php foreach ($playlists as $playlist){echo "<option value=\"$playlist\">$playlist</option>\n";} ?>
			</select>
		</div>
	</div>

	<div class="form-group" >
		<label class="control-label col-sm-3" for="hostname">Days: </label>
		<div class="col-sm-9">
			<div style="float:left;"><input type="checkbox" name="add[alarmday1]" id="addalarmday1" value="1" class="checkbox-input" checked /><label for="addalarmday1" class="pseudo-checkbox">Mo</label></div>
			<div style="float:left;"><input type="checkbox" name="add[alarmday2]" id="addalarmday2" value="2" class="checkbox-input" checked /><label for="addalarmday2" class="pseudo-checkbox">Tu</label></div>
			<div style="float:left;"><input type="checkbox" name="add[alarmday3]" id="addalarmday3" value="3" class="checkbox-input" checked /><label for="addalarmday3" class="pseudo-checkbox">We</label></div>
			<div style="float:left;"><input type="checkbox" name="add[alarmday4]" id="addalarmday4" value="4" class="checkbox-input" checked /><label for="addalarmday4" class="pseudo-checkbox">Th</label></div>
			<div style="float:left;"><input type="checkbox" name="add[alarmday5]" id="addalarmday5" value="5" class="checkbox-input" checked /><label for="addalarmday5" class="pseudo-checkbox">Fr</label></div>
			<div style="float:left;clear:left"><input type="checkbox" name="add[alarmday6]" id="addalarmday6" value="6" class="checkbox-input"         /><label for="addalarmday6" class="pseudo-checkbox">Sa</label></div>
			<div style="float:left;"><input type="checkbox" name="add[alarmday7]" id="addalarmday7" value="7" class="checkbox-input"         /><label for="addalarmday7" class="pseudo-checkbox">Su</label></div>
		</div>
	</div>

	<div class="form-group" >
		<label class="control-label col-sm-3" for="hostname">Volume: </label>
		<div class="col-sm-9">
			<select name="add[alarmvolume]" class="btn dropdown btn-default btn-lg" style="visibility:visible;">
				<?php for ($i = 10; $i <= 100; $i+=10){echo "<option value=\"$i\">$i %</option>\n";} ?>
			</select>
		</div>
	</div>

	<div class="form-group" >
		<label class="control-label col-sm-3" for="hostname">Fade: </label>
		<div class="col-sm-9">
			<select name="add[alarmfadetime]" class="btn dropdown btn-default btn-lg" style="visibility:visible;">
				<?php $fadetimearray = array(0,1,5,10,15,30);
						foreach ($fadetimearray as $i){
							echo "<option value=\"$i\">$i min</option>\n";
						}
				?>
			</select>
		</div>
	</div>

	<div class="form-group" >
		<label class="control-label col-sm-3" for="hostname">Timeout: </label>
		<div class="col-sm-9">
			<select name="add[alarmtimeout]" class="btn dropdown btn-default btn-lg" style="visibility:visible;">
				<?php $timeoutarray = array(0,30,60,90,120,180,240);
						foreach ($timeoutarray as $i){
							echo "<option value=\"$i\">$i min</option>\n";
						}
				?>
			</select>
		</div>
	</div>

	<div class="form-group">
		<div class="col-sm-12">
			<button type="submit" class="btn btn-default btn-lg pull-right" name="add[todo]" value="add">Add Alarm</button>
		</div>
	</div>
</div>
</fieldset>
</form>
</div>



